unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Rtti, System.Classes,
  System.Variants, System.IniFiles,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.Edit, FMX.Layouts;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    GridLayout1: TGridLayout;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Edit1: TEdit;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Button16: TButton;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; var KeyChar: Char;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
  private
    { private 錾 }
    vari,prev : double;
    flg1,flg2,flg3 : Boolean;
    func : integer;
    procedure OpenIniFile;
    procedure SaveIniFile;
    procedure Button_0_9_Click(k:string);
    procedure CalcDisp ;
  public
    { public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

// lɕϊ
function SDbl(s:string) : double;
var
	j : Integer;
	w : double;
begin
	if (s = '') then
   	w := 0.0
   else begin
      Val(s,w,j);
      if (j <> 0) then w := 0.0;
   end;
   Result := w;
end;

procedure TForm1.OpenIniFile;
var
    IniFile : TIniFile;
begin
   IniFile := TIniFile.Create(ChangeFileExt(ParamStr(0),'.ini'));
   try
      Form1.Left  := IniFile.ReadInteger('Form','X',0);
      Form1.Top   := IniFile.ReadInteger('Form','Y',0);
      Form1.Width := IniFile.ReadInteger('Form','W',320);
      Form1.Height:= IniFile.ReadInteger('Form','H',240);
   except
      ;
   end;
   IniFile.Free;
end;

procedure TForm1.SaveIniFile;
var
    IniFile : TIniFile;
begin
   IniFile := TIniFile.Create(ChangeFileExt(ParamStr(0),'.ini'));
   try
      IniFile.WriteInteger('Form','X', Form1.Left);
      IniFile.WriteInteger('Form','Y', Form1.Top);
      IniFile.WriteInteger('Form','W', Form1.Width);
      IniFile.WriteInteger('Form','H', Form1.Height);
   except
      ;
   end;
   IniFile.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   OpenIniFile;
   Label1.Text := '';
   Edit1.Text  := '';
   vari:= 0.0;    // P
   prev:= 0.0;    // O varil̃obNAbv@u=vA͂̍ۂɗp
   flg1:= False;  // (P);False  p(Q):True
   flg2:= False;  // l͒:False  l͂ĂȂ:True
   flg3:= False;  // u=vTrue
   func:= 0;      // Z@\ԍ 1:+ 2:- 3:* 4:/
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   SaveIniFile;
end;

procedure TForm1.FormResize(Sender: TObject);
var
   i : integer;
   cp: TComponent;
begin
   GridLayout1.ItemWidth := GridLayout1.Width /4;
   GridLayout1.ItemHeight:= GridLayout1.Height/4;
   for i := 1 to 16 do begin
      cp := FindComponent('Button'+IntToStr(i));
      TButton(cp).Font.Size := GridLayout1.ItemHeight * 0.5;
   end;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; var KeyChar: Char;
  Shift: TShiftState);
var
   s : string;
begin
   s := Edit1.Text;
   if (KeyChar >= '0')and(KeyChar <= '9') then begin
      Button_0_9_Click(KeyChar);
   end
   else if (KeyChar = '.') then
      Button14Click(Sender)
   else if (KeyChar = '+') then
      Button16Click(Sender)
   ;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   Button_0_9_Click(TButton(Sender).Text);
end;

// [0]-[9]
procedure TForm1.Button_0_9_Click(k:string);
begin
   if (flg2) then begin
      Edit1.Text := '';
      flg2 := False;
   end;
   if (flg3) then begin
      func := 0;
      flg1 := False;
      flg3 := False;
   end;

   Edit1.Text := Edit1.Text + k;
end;

// [.]
procedure TForm1.Button14Click(Sender: TObject);
var
   s : string;
begin
   if (flg2) then begin
      Edit1.Text := '';
      flg2 := False;
   end;
   if (flg3) then begin
      func := 0;
      flg1 := False;
      flg3 := False;
   end;

   s := Edit1.Text;
   if (s.IndexOf('.') = -1) then begin
      Edit1.Text := s + '.';
   end;
end;

// [+]
procedure TForm1.Button16Click(Sender: TObject);
var
   s : string;
begin
   s := Edit1.Text;
   if (flg2) then s := '';
   if (flg3) then flg3 := False;
   if not(flg1) then begin
      // ԁPp[^
      if (s = '')or(s = '-')or(s = '+') then begin
         Edit1.Text := '+';
         flg2 := False;
         exit;
      end;
      vari := SDbl(s);
      flg1 := True;
   end
   else begin
      // pԁQp[^Z
      if (s = '') then begin
         func := 1;
         exit;
      end;
      CalcDisp;
   end;
   func := 1;
   flg2 := True;
end;

// [-]
procedure TForm1.Button12Click(Sender: TObject);
var
   s : string;
begin
   s := Edit1.Text;
   if (flg2) then s := '';
   if (flg3) then flg3 := False;
   if not(flg1) then begin
      // ԁPp[^
      if (s = '')or(s = '-')or(s = '+') then begin
         Edit1.Text := '-';
         flg2 := False;
         exit;
      end;
      vari := SDbl(s);
      flg1 := True;
   end
   else begin
      // pԁQp[^Z
      if (s = '') then begin
         func := 2;
         exit;
      end;
      CalcDisp;
   end;
   func := 2;
   flg2 := True;
end;

// [~]
procedure TForm1.Button8Click(Sender: TObject);
var
   s : string;
begin
   s := Edit1.Text;
   if (flg2) then s := '';
   if (flg3) then flg3 := False;
   if not(flg1) then begin
      // ԁPp[^
      if (s = '')or(s = '-')or(s = '+') then exit;
      vari := SDbl(s);
      flg1 := True;
   end
   else begin
      // pԁQp[^Z
      if (s = '') then begin
         func := 3;
         exit;
      end;
      CalcDisp;
   end;
   func := 3;
   flg2 := True;
end;

// []
procedure TForm1.Button4Click(Sender: TObject);
var
   s : string;
begin
   s := Edit1.Text;
   if (flg2) then s := '';
   if (flg3) then flg3 := False;
   if not(flg1) then begin
      // ԁPp[^
      if (s = '')or(s = '-')or(s = '+') then exit;
      vari := SDbl(s);
      flg1 := True;
   end
   else begin
      // pԁQp[^Z
      if (s = '') then begin
         func := 4;
         exit;
      end;
      CalcDisp;
   end;
   func := 4;
   flg2 := True;
end;

// []
procedure TForm1.Button15Click(Sender: TObject);
var
   s : string;
begin
   s := Edit1.Text;
   if (flg2) then s := '';
   if (flg1) then begin
      // p
      if (s = '') then begin
         Edit1.Text := FloatToStr(prev);
      end;
      CalcDisp;
   end;
   flg2 := True;
   flg3 := True;
end;

// vZ
procedure TForm1.CalcDisp ;
var
   d : double;
begin
   if (func < 1) then exit;
   d := SDbl(Edit1.Text);
   case func of
   1: begin
         Label1.Text := FloatToStr(vari) + ' + ' + FloatToStr(d) + ' = ';
         vari := vari + d;
      end;
   2: begin
         Label1.Text := FloatToStr(vari) + ' - ' + FloatToStr(d) + ' = ';
         vari := vari - d;
      end;
   3: begin
         Label1.Text := FloatToStr(vari) + ' ~ ' + FloatToStr(d) + ' = ';
         vari := vari * d;
      end;
   4: begin
         Label1.Text := FloatToStr(vari) + '  ' + FloatToStr(d) + ' = ';
         try
            vari := vari / d;
         except
            vari := 0.0;
         end;
      end;
   end;
   Edit1.Text := FloatToStr(vari);
   Label1.Text := Label1.Text + FloatToStr(vari);
   prev := d;
end;


end.
